Index: palm/trunk/EXAMPLES/agents/canyon/INPUT/canyon_p3d
===================================================================
--- palm/trunk/EXAMPLES/agents/canyon/INPUT/canyon_p3d	(revision 3159)
+++ palm/trunk/EXAMPLES/agents/canyon/INPUT/canyon_p3d	(revision 3159)
@@ -0,0 +1,70 @@
+&initialization_parameters
+   !-- grid setup
+      nx = 19,
+      ny = 19,
+      nz = 20,
+
+      dx = 2.0,
+      dy = 2.0,
+      dz = 2.0,
+
+   !-- pressure solver
+      fft_method = 'temperton-algorithm',
+    loop_optimization    = 'cache',
+
+   !-- initialization
+      initializing_actions = 'set_constant_profiles',  ! constant vertical profiles are used,
+      pt_surface = 300.,                               ! based on given "*_surface" values
+      ug_surface = 1.0,
+      vg_surface = 0.0, 
+
+   !-- boundary conditions
+      bc_uv_t = 'neumann',                    ! free-slip boundary condition
+      bc_pt_b = 'dirichlet',                  ! surface temperature is calculated by e-balance solver in USM  
+      bc_pt_t = 'neumann',      
+      roughness_length = 0.1,                 ! applies to all surfaces
+
+   !-- topography   
+      topography = 'read_from_file',                ! file: generic_canyon_topo
+      
+   !-- other
+    most_method          = 'newton',
+      /                                       ! end of inipar-namelist
+
+
+ &runtime_parameters
+   !-- simulation time
+      end_time                = 200.0, 
+
+   !-- others
+      create_disturbances = .T.,
+
+      netcdf_data_format = 5,
+      dt_dots = 9999999.,
+                    
+      /                                        ! end of canopy_par-namelist
+
+
+ &agents_par
+    dt_arel                = 3.1,
+    dt_write_agent_data    = .1,
+    dt_agent = 0.02,
+    number_of_agent_groups = 2,
+    adx                    = 1.8,1.8,
+    ady                    = 1.,1.,
+    asl                    = 13.,13.,
+    asr                    = 27.,27.,
+    ass                    = .5,38.,
+    asn                    = 2.,39.5,
+    at_x                   = 20.,20.,
+    at_y                   = 999.,-999.,  ! chosen far out of domain so that agents walk nearly parallel
+
+
+    /
+
+
+
+ &prepro_par
+      tolerance_dp  = 1.41, 1.41,
+
+    /
Index: palm/trunk/EXAMPLES/agents/canyon/INPUT/canyon_topo
===================================================================
--- palm/trunk/EXAMPLES/agents/canyon/INPUT/canyon_topo	(revision 3159)
+++ palm/trunk/EXAMPLES/agents/canyon/INPUT/canyon_topo	(revision 3159)
@@ -0,0 +1,20 @@
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+ 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
Index: palm/trunk/EXAMPLES/agents/canyon/OUTPUT/ani_agt.py
===================================================================
--- palm/trunk/EXAMPLES/agents/canyon/OUTPUT/ani_agt.py	(revision 3159)
+++ palm/trunk/EXAMPLES/agents/canyon/OUTPUT/ani_agt.py	(revision 3159)
@@ -0,0 +1,85 @@
+#!/usr/bin/env python3
+
+import matplotlib
+import sys
+from matplotlib import colors, ticker, cm
+from matplotlib.backends.backend_pdf import PdfPages
+from netCDF4 import Dataset
+import matplotlib.pyplot as plt
+import numpy as np
+import math
+from matplotlib import animation
+import matplotlib.gridspec as gridspec
+from matplotlib.lines import Line2D
+from matplotlib.collections import PatchCollection
+from matplotlib.patches import Polygon
+matplotlib.rcParams['text.usetex'] = True
+
+
+input_file_name  = './canyon_agt.001.nc'
+
+file_content     = Dataset(input_file_name, mode='r') # load entire netCDF file
+print(file_content)
+time          = file_content.variables['time'][:] # extract variable
+agx           = file_content.variables['ag_x'][:,:]
+agy           = file_content.variables['ag_y'][:,:]
+grp           = file_content.variables['ag_group'][:,:]
+file_content.close() # close netCDF file
+
+input_file_name  = './topo.txt'
+f     = open(input_file_name, mode='r')
+data = []
+building_id = []
+vertex_id = []
+polygon = []
+gons = []
+p_last = 1
+for line in f:
+  line = line.strip()
+  columns = line.split()
+  if (int(columns[0]) > p_last):
+    gons.append(polygon)
+    polygon = []
+  polygon.append([float(columns[2]),float(columns[3])])
+  p_last = int(columns[0])
+gons.append(polygon)
+nop = int(columns[0])
+patches = []
+
+for i in range(nop):
+  poly = Polygon(gons[i-1], True)
+  patches.append(poly)
+p = PatchCollection(patches,facecolors='grey')
+
+Nt = np.shape(time)[0]
+print(Nt)
+Nt = Nt -1
+Nags = np.shape(agx[1,:])
+Nx = 40
+Ny = 40
+
+x = np.linspace(0.0, 40.0, Nx)
+y = np.linspace(0.0, 40.0, Ny)
+X, Y = np.meshgrid(x, y)
+
+fig,ax = plt.subplots()
+fig.set_size_inches(4., 8.)
+xrange = [10, 30]
+yrange = [0, 40]
+
+
+def animate(i):
+    ax.clear()
+    ax.add_collection(p)
+    x = agx[i,:]
+    y = agy[i,:]
+    ax.set_xlim(*xrange)
+    ax.set_ylim(*yrange)
+    ax.scatter(x,y,s=15,c=grp[i,:])
+    plt.title(r'simulated time: %i s' % time[i])
+    k = i/Nt*100.
+    print("Done: %6.2f percent\r" % k, file=sys.stdout, end=" ")
+    return ax,
+
+anim = animation.FuncAnimation(fig, animate, frames=Nt, interval=60, blit=False,save_count=0)
+anim.save('ags.mp4', dpi=200, writer='ffmpeg')
Index: palm/trunk/EXAMPLES/agents/corners/INPUT/corners_p3d
===================================================================
--- palm/trunk/EXAMPLES/agents/corners/INPUT/corners_p3d	(revision 3159)
+++ palm/trunk/EXAMPLES/agents/corners/INPUT/corners_p3d	(revision 3159)
@@ -0,0 +1,61 @@
+&initialization_parameters
+   !-- grid setup
+      nx = 19,
+      ny = 19,
+      nz = 30,
+
+      dx = 1.0,
+      dy = 1.0,
+      dz = 1.0,
+
+   !-- pressure solver
+      fft_method = 'temperton-algorithm',
+    loop_optimization    = 'cache',
+
+   !-- initialization
+      initializing_actions = 'set_constant_profiles',  ! constant vertical profiles are used,
+      pt_surface = 300.,                               ! based on given "*_surface" values
+      ug_surface = 1.0,
+      vg_surface = 0.0, 
+
+   !-- boundary conditions
+      bc_uv_t = 'neumann',                    ! free-slip boundary condition
+      bc_pt_b = 'dirichlet',                  ! surface temperature is calculated by e-balance solver in USM  
+      bc_pt_t = 'neumann',      
+      roughness_length = 0.01,                 ! applies to all surfaces
+
+   !-- topography   
+      topography = 'read_from_file',                ! file: generic_canyon_topo
+      
+   !-- other
+    most_method          = 'newton',
+      /                                       ! end of inipar-namelist
+
+
+ &runtime_parameters  
+   !-- simulation time
+      end_time                = 150.0, 
+
+   !-- others
+      create_disturbances = .T.,
+
+      netcdf_data_format = 5,
+      dt_dots            = 9999999.,
+                    
+      /                                        ! end of canopy_par-namelist
+
+
+ &agents_par
+    dt_arel                = 12.,
+    dt_write_agent_data    = .05,
+    number_of_agent_groups = 4,
+    adx                    =   .9,   .9,   4.,   4.,
+    ady                    =   4.,   4.,   .9,   .9,
+    asl                    =   8.,   8.,  1.5,  18.,
+    asr                    =  12.,  12.,   2., 18.5,
+    ass                    =  1.5,  18.,   8.,   8., 
+    asn                    =   2., 18.5,  12.,  12.,
+    at_x                   =  10.,  10.,  16.,   4.,
+    at_y                   =  16.,   4.,  10.,  10.,
+
+    /
Index: palm/trunk/EXAMPLES/agents/corners/INPUT/corners_topo
===================================================================
--- palm/trunk/EXAMPLES/agents/corners/INPUT/corners_topo	(revision 3159)
+++ palm/trunk/EXAMPLES/agents/corners/INPUT/corners_topo	(revision 3159)
@@ -0,0 +1,20 @@
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0 20.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
+  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0  0.0
Index: palm/trunk/EXAMPLES/agents/corners/OUTPUT/ani_agt.py
===================================================================
--- palm/trunk/EXAMPLES/agents/corners/OUTPUT/ani_agt.py	(revision 3159)
+++ palm/trunk/EXAMPLES/agents/corners/OUTPUT/ani_agt.py	(revision 3159)
@@ -0,0 +1,103 @@
+#!/usr/bin/env python3
+
+import matplotlib
+import sys
+from matplotlib import colors, ticker, cm
+from matplotlib.backends.backend_pdf import PdfPages
+from netCDF4 import Dataset
+import matplotlib.pyplot as plt
+import numpy as np
+import math
+from matplotlib import animation
+import matplotlib.gridspec as gridspec
+from matplotlib.lines import Line2D
+from matplotlib.collections import PatchCollection
+from matplotlib.patches import Polygon
+matplotlib.rcParams['text.usetex'] = True
+
+
+input_file_name  = './corners_agt.059.nc'
+
+file_content     = Dataset(input_file_name, mode='r') # load entire netCDF file
+print(file_content)
+time          = file_content.variables['time'][:] # extract variable
+agx           = file_content.variables['ag_x'][:,:]
+agy           = file_content.variables['ag_y'][:,:]
+group           = file_content.variables['ag_group'][:,:]
+file_content.close() # close netCDF file
+
+input_file_name  = './topo.txt'
+f     = open(input_file_name, mode='r')
+data = []
+building_id = []
+vertex_id = []
+polygon = []
+gons = []
+p_last = 1
+for line in f:
+  line = line.strip()
+  columns = line.split()
+  if (int(columns[0]) > p_last):
+    gons.append(polygon)
+    polygon = []
+  polygon.append([float(columns[2]),float(columns[3])])
+  p_last = int(columns[0])
+gons.append(polygon)
+nop = int(columns[0])
+patches = []
+
+for i in range(nop):
+  poly = Polygon(gons[i-1], True)
+  patches.append(poly)
+p = PatchCollection(patches,facecolors='grey')
+
+input_file_name  = './topo_nav.txt'
+f     = open(input_file_name, mode='r')
+t_x = []
+t_y = []
+
+l_count = 0
+for line in f:
+  l_count = l_count + 1
+  line = line.strip()
+  columns_t = line.split()
+  t_x.append(columns_t[2])
+  t_y.append(columns_t[3])
+
+Nt = np.shape(time)[0]
+print(Nt)
+Nt = Nt -1
+Nags = np.shape(agx[1,:])
+Nx = 20
+Ny = 20
+
+x = np.linspace(0.0, 20.0, Nx)
+y = np.linspace(0.0, 20.0, Ny)
+X, Y = np.meshgrid(x, y)
+
+fig,ax = plt.subplots()
+fig.set_size_inches(7., 7.)
+xrange = [0, 20]
+yrange = [0, 20]
+colors = ['yellow','red','blue']
+
+
+def animate(i):
+    ax.clear()
+    ax.add_collection(p)
+    x = agx[i,:]
+    y = agy[i,:]
+    ax.set_xlim(*xrange)
+    ax.set_ylim(*yrange)
+    ax.scatter(x,y,s=3,c=group[i,:])
+    ax.scatter(t_x,t_y,s=1,c='red')
+    plt.title(r'simulated time: %i s' % time[i])
+    k = i/Nt*100.
+    print("Done: %6.2f percent\r" % k, file=sys.stdout, end=" ")
+    return ax,
+
+anim = animation.FuncAnimation(fig, animate, frames=Nt, interval=60, blit=False,save_count=0)
+anim.save('ags.mp4', dpi=200, writer='ffmpeg')
+#anim.save('basic_animation.gif', fps=1, extra_args=['-vcodec', 'libx264'])
+
+#plt.show()
Index: palm/trunk/SCRIPTS/.palm.iofiles
===================================================================
--- palm/trunk/SCRIPTS/.palm.iofiles	(revision 3157)
+++ palm/trunk/SCRIPTS/.palm.iofiles	(revision 3159)
@@ -6,4 +6,5 @@
 PARIN                    in:tr      d3r      $base_data/$jobname/INPUT          _p3dr*
 PARIN                    in:tr      pcr      $base_data/$jobname/INPUT          _pcr*
+NAVIGATION_DATA          inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _nav*
 TOPOGRAPHY_DATA          inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _topo*
 PIDS_STATIC              inopt:tr   d3#:d3r  $base_data/$jobname/INPUT          _static*
@@ -62,4 +63,5 @@
 DATA_MASK_NETCDF*          out:tr   *         $base_data/$jobname/OUTPUT         _masked    nc
 DATA_MASK_AV_NETCDF*       out:tr   *         $base_data/$jobname/OUTPUT         _av_masked nc
+DATA_AGT_NETCDF            out:tr   *         $base_data/$jobname/OUTPUT         _agt       nc
 #
 DATA_PRT_NETCDF*           out:pe   *         $base_data/$jobname/OUTPUT         _prt
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 3157)
+++ palm/trunk/SOURCE/Makefile	(revision 3159)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# Added multi agent system
+# 
+# 3130 2018-07-16 11:08:55Z gronemeier
 # add surface_layer_fluxes_mod to turbulence_closure_mod
 # 
@@ -537,4 +540,5 @@
 	mod_particle_attributes.f90 \
 	modules.f90 \
+	multi_agent_system_mod.f90 \
 	netcdf_data_input_mod.f90 \
 	netcdf_interface_mod.f90 \
@@ -1177,4 +1181,11 @@
 modules.o: \
 	mod_kinds.o
+multi_agent_system_mod.o: \
+	chemistry_model_mod.o \
+	cpulog_mod.o \
+	mod_kinds.o \
+	modules.o \
+	netcdf_interface_mod.o \
+	surface_mod.o
 mod_kinds.o: \
 
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 3157)
+++ palm/trunk/SOURCE/check_open.f90	(revision 3159)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added multi agent system
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Output case 108 disabled
 ! 
@@ -190,8 +193,9 @@
 
     USE netcdf_interface,                                                      &
-        ONLY:  id_set_fl, id_set_mask, id_set_pr, id_set_prt, id_set_pts,      &
-               id_set_sp, id_set_ts, id_set_xy, id_set_xz, id_set_yz,          &
-               id_set_3d, nc_stat, netcdf_create_file, netcdf_data_format,     &
-               netcdf_define_header, netcdf_handle_error, netcdf_open_write_file
+        ONLY:  id_set_agt, id_set_fl, id_set_mask, id_set_pr, id_set_prt,      &
+               id_set_pts, id_set_sp, id_set_ts, id_set_xy, id_set_xz,         &
+               id_set_yz, id_set_3d, nc_stat, netcdf_create_file,              &
+               netcdf_data_format, netcdf_define_header, netcdf_handle_error,  &
+               netcdf_open_write_file
 
     USE particle_attributes,                                                   &
@@ -1077,4 +1081,62 @@
           ENDIF
 
+       CASE ( 118 )
+
+          IF ( myid == 0 )  THEN
+             filename = 'DATA_AGT_NETCDF'
+!
+!--       Inquire, if there is a netCDF file from a previuos run. This should
+!--       be opened for extension, if its variables match the actual run.
+          INQUIRE( FILE=filename, EXIST=netcdf_extend )
+
+!
+!--          Create a new netCDF output file with requested netCDF format
+             CALL netcdf_create_file( filename, id_set_agt, .FALSE., 43 )
+
+!
+!--          Define the header
+             CALL netcdf_define_header( 'ag', netcdf_extend, 0 )
+          ENDIF
+
+!           IF ( netcdf_extend )  THEN
+! !
+! !--          Open an existing netCDF file for output
+!              CALL netcdf_open_write_file( filename, id_set_agt, .FALSE., 41 )
+! !
+! !--          Read header information and set all ids. If there is a mismatch
+! !--          between the previuos and the actual run, netcdf_extend is returned
+! !--          as .FALSE.
+!              CALL netcdf_define_header( 'ag', netcdf_extend, 0 )
+! 
+! !
+! !--          Remove the local file, if it can not be extended
+!              IF ( .NOT. netcdf_extend )  THEN
+!                 nc_stat = NF90_CLOSE( id_set_agt )
+!                 CALL netcdf_handle_error( 'check_open', 42 )
+!                 CALL local_system( 'rm ' // TRIM( filename ) )
+!              ENDIF
+! 
+!           ENDIF
+
+          IF ( .NOT. netcdf_extend )  THEN
+
+!
+! !--          For runs on multiple processors create the subdirectory
+!              IF ( myid_char /= '' )  THEN
+!                 IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  &
+!                 THEN    ! needs modification in case of non-extendable sets
+!                    CALL local_system( 'mkdir  DATA_PRT_NETCDF' //              &
+!                                        TRIM( coupling_char ) // '/' )
+!                 ENDIF
+! #if defined( __parallel )
+! ! 
+! !--             Set a barrier in order to allow that all other processors in the
+! !--             directory created by PE0 can open their file
+!                 CALL MPI_BARRIER( comm2d, ierr )
+! #endif
+!              ENDIF
+
+          ENDIF
+
 !
 !--    nc-file for virtual flight measurements
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 3157)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 3159)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added multi agent system
+! 
+! 3129 2018-07-16 07:45:13Z gronemeier
 ! Move initialization call for nudging and 1D/3D offline nesting. 
 ! Revise initialization with inifor data.
@@ -506,12 +509,12 @@
     
     USE indices
+    
+    USE kinds
+
+    USE land_surface_model_mod,                                                &
+        ONLY:  lsm_init, lsm_init_arrays
 
     USE lpm_init_mod,                                                          &
         ONLY:  lpm_init
-    
-    USE kinds
-
-    USE land_surface_model_mod,                                                &
-        ONLY:  lsm_init, lsm_init_arrays
   
     USE lsf_nudging_mod,                                                       &
@@ -524,4 +527,7 @@
         ONLY:  e1d, init_1d_model, kh1d, km1d, l1d, rif1d, u1d, us1d, usws1d,  &
                v1d, vsws1d 
+
+    USE multi_agent_system_mod,                                                &
+        ONLY:  agents_active, mas_init
 
     USE netcdf_interface,                                                      &
@@ -2367,4 +2373,8 @@
 
 !
+!-- If required, initialize particles
+    IF ( agents_active )  CALL mas_init
+
+!
 !-- If required, initialize quantities needed for the LSM
     IF ( land_surface )  THEN
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 3157)
+++ palm/trunk/SOURCE/modules.f90	(revision 3159)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added multi agent system
+! 
+! 3157 2018-07-19 21:08:49Z maronga
 ! added use_free_convection_scaling
 ! 
@@ -1149,4 +1152,5 @@
     
     INTEGER(iwp) ::  abort_mode = 1                    !< abort condition (nested runs)
+    INTEGER(iwp) ::  agt_time_count = 0                !< number of output intervals for agent data output
     INTEGER(iwp) ::  average_count_pr = 0              !< number of samples in vertical-profile output
     INTEGER(iwp) ::  average_count_3d = 0              !< number of samples in 3d output
@@ -1262,4 +1266,5 @@
     LOGICAL ::  aerosol_c3h4o4 =.FALSE.                          !< malonic acid aerosol for bulk scheme
     LOGICAL ::  aerosol_nh4no3 =.FALSE.                          !< malonic acid aerosol for bulk scheme
+    LOGICAL ::  agent_time_unlimited = .FALSE.                   !< namelist parameter
     LOGICAL ::  air_chemistry = .FALSE.                          !< chemistry model switch
     LOGICAL ::  bc_lr_cyc =.TRUE.                                !< left-right boundary condition cyclic?
@@ -1299,4 +1304,5 @@
     LOGICAL ::  dt_3d_reached_l                                  !< internal timestep for particle advection
     LOGICAL ::  first_call_lpm = .TRUE.                          !< call lpm only once per timestep?
+    LOGICAL ::  first_call_mas = .TRUE.                          !< call mas only once per timestep
     LOGICAL ::  force_print_header = .FALSE.                     !< namelist parameter
     LOGICAL ::  force_bound_l = .FALSE.                          !< flag indicating domain boundary on left side to set forcing boundary conditions
@@ -1436,4 +1442,5 @@
     REAL(wp) ::  dt_run_control = 60.0_wp                      !< namelist parameter
     REAL(wp) ::  dt_spinup = 60.0_wp                           !< namelist parameter
+    REAL(wp) ::  dt_write_agent_data = 9999999.9_wp            !< namelist parameter
     REAL(wp) ::  dt_3d = 0.01_wp                               !< time step
     REAL(wp) ::  dz_max = 1000.0_wp                            !< namelist parameter
